#include <linuxmt/types.h>
#include <linuxmt/sched.h>

__arch_mminit arch_segs;
int arch_cpu;			/* Processor type */

/* This is a generic lib function... */

void *memcpy(dest, src, len)
void *dest;
void *src;
__uint len;
{
	int c;

	for (c = 0; c < len; c++)
		((__pu8)dest)[c] = ((__pu8)src)[c];

	return dest;
}

void setup_arch()
{
	int ct;
/*
 *	Save segments
 */
#asm
	mov bx, #_arch_segs
	mov ax, cs
	mov [bx], ax
	mov [bx+2], di
	mov ax, ss
	mov [bx+8], ax
	mov [bx+6], si
!	This is out of order to save a segment load and a few bytes :)
	mov ax, ds
	mov [bx+4], ax
	mov [bx+10], dx
	mov ds, ax
#endasm
	arch_segs.lowss = arch_segs.endss;
/*
 *	This wonderful chunk of strangeness C/O ajkroll@buffnet.net
 */
#asm
	mov	_arch_cpu,#0
	pushf
	pushf
	pop 	ax
	and	ax,#0xFFF
	push 	ax
	popf
	pushf
	pop	ax
	push 	ax
	popf
	and	ax,#0xf000
	cmp	ax,#0xf000
	je	xtchip
	mov	_arch_cpu,#2
xtchip:
	popf
#endasm
	
	/*
	 *	Now create task 0 to be ourself. Set the kernel SP,
	 *	as we will need this in interrupts.
	 */	

 	task[0].state = TASK_RUNNING;
	task[0].t_count=0;
	task[0].t_priority=0;
	task[0].t_regs.ksp=&task[0].t_kstack+126;
	task[0].t_priority=10;
	task[0].t_count=0;
	
	current = &task[0];
	curnum = 0;
	
	/*
	 *	Mark tasks 1-31 as not in use.
	 */
	for(ct=1;ct<MAX_TASKS;ct++)
		task[ct].state=TASK_UNUSED;
}

